#Agent.py
from Tools import *
import graphicDisplayGlobalVarAndFunctions as gvf

class Agent:
    def __init__(self, number,myWorldState,
                 xPos=0, yPos=0, lX =-20,rX=19, bY=-20,tY=19, agType=""):
        # the environment
        self.agOperatingSets=[]
        self.number = number
        self.lX = lX
        self.rX = rX
        self.bY = bY
        self.tY = tY
        self.myWorldState = myWorldState
        self.agType=agType

        # the graph
        if gvf.getGraph() == 0: gvf.createGraph()
        g=gvf.getGraph()
        
        # the agent
        if self.agType == "factory":
         print "agent", self.agType, "#", self.number, \
        	      "has been created at", xPos, ",", yPos
         g.add_node(self)
         gvf.colors[self]="y"
         #print gvf.colors
         gvf.pos[self]=(xPos,yPos)
         gvf.labels[self]=number
         
        if self.agType == "recipe":
         print "agent", self.agType, "#", self.number, \
        	      "has been created"
         

    # add operating an set
    def setAnOperatingSet(self,aSet):
        self.agOperatingSets.append(aSet)

    # get operating set list
    def getOperatingSetList(self):
        return self.agOperatingSets

    # reset values
    def setNewCycleValues(self):
        pass # here is only reported for future uses

    def getAgType(self):
        return self.agType

    
    # ",**d" in the parameter lists of the methods is a place holder
    # in case we use, calling the method, a dictionary as last par

    # eating (to be developed)
    def makeStep(self,**d):
        print "%s agent # %d: " % (self.agType,self.number),
        print "makes a step"


