#global variables and functions for graphic display management
#to be imported with
#import graphicDisplayGlobalVarAndFunctions as gvf

import networkx as nx
import matplotlib.pyplot as plt

def findNodeFromLabel(label):
    for i in range(len(labels)):
        if labels.items()[i][1]==label:
            return labels.items()[i][0]

# using networkX and matplotlib case 
def closeNetworkXdisplay(): 
    plt.close()

def openClearNetworkXdisplay():
    plt.ion()
    plt.clf()

def getGraph():
    try:
        return agentGraph
    except:
        return 0

def createGraph():
    global agentGraph, colors, pos, labels
    agentGraph=nx.DiGraph() # directed graph, instead of nx.Graph()
    colors={}
    pos={}
    labels={}

def drawGraph():

    a=findNodeFromLabel(1002)
    b=findNodeFromLabel(1001)

    #directed, due to DiGraph
    agentGraph.add_edge(a,b)
    #agentGraph.add_edges_from([(agentGraph.nodes()[0],agentGraph.nodes()[1])])


    # draw_netwokx is well documented at
    # https://networkx.github.io/documentation/latest/reference/
    # generated/networkx.drawing.nx_pylab.draw_networkx.html 
    # nx.draw_networkx(agentGraph,    font_size=10,node_size=500, \
    nx.draw_networkx(agentGraph,pos,font_size=10,node_size=500, \
         node_color=colors.values(), \
         labels = labels)
    plt.draw()
    #print agentGraph.nodes(), labels
    #print findNodeFromLabel(1001), findNodeFromLabel(1002), findNodeFromLabel(1003) 
